{$O+,F+}
unit trdos;
interface
const
{  訡 }
    eOk=0;
    eBadController =1;
    eTimeOut       =2;
    eSeekError     =3;
    eDriveNotReady =4;
    eEndOfCylinder =5;
    eBadSector     =6;
    eDMAError      =7;
    eSectorNotFound=8;
    eWriteProtect  =9;
    eUnknownError  =10;
Type
    TFDCBuf=array[0..4095] of byte;
Var
    FDCbuf              :TFDCBuf;
    status              :array[0..7] of byte;
    IOError             :Byte;
    DMAPage, DMAOfs     :word;
    HobetaBug           :boolean;

function ErrorStr(err:byte):string;
procedure StartDrive(drv:byte);
procedure zxSeek(drv,trck:byte);
procedure ReadSector(drv,trck,hd,sctr,qnt:byte);
procedure WriteSector(drv,trck,hd,sctr,qnt:byte);
Procedure FormatTrack(Drv,Trck,Had:Byte; HB:boolean);
function initFDD(drv:byte; init:boolean):boolean;

implementation
uses crt;
{----------------------------------------------------------------------------}
function ErrorStr(err:byte):string;
begin
 Case err of
  0: ErrorStr:='Ok              ';
  1: ErrorStr:='Bad Controller  ';
  2: ErrorStr:='Time Out        ';
  3: ErrorStr:='Seek Error      ';
  4: ErrorStr:='Drive Not Ready ';
  5: ErrorStr:='End Of Cylinder ';
  6: ErrorStr:='Bad Sector      ';
  7: ErrorStr:='DMA Error       ';
  8: ErrorStr:='Sector Not Found';
  9: ErrorStr:='Write Protect   ';
  10:ErrorStr:='Unknown Error   ';
  27:ErrorStr:='User Break      ';
 End;
end;

{----------------------------------------------------------------------------}
Function TestBit(Num, Bit: Byte): Boolean;
Const Bits: ARRAY[0..7] OF Word = (1,2,4,8,16,32,64,128);
begin
  TestBit:=(Num AND Bits[Bit])<>0;
end;

{----------------------------------------------------------------------------}
Function In_FDC: Byte; VAR i: LongInt; begin
  i:=128;
  While (port[$3F4] AND $C0)<>$C0 DO BEGIN Dec(i); IF i=0 THEN Exit; END;
  IF i<>0 THEN In_FDC:=port[$3F5] ELSE IOError:=eTimeOut;
end;

{----------------------------------------------------------------------------}
Procedure Out_FDC(Comm: Byte); VAR i: LongInt; begin
  i:=128;
  While (port[$3F4] AND $C0)<>$80 DO BEGIN Dec(i); IF i=0 THEN Exit; END;
  IF i<>0 THEN port[$3F5]:=Comm ELSE IOError:=eTimeOut;
end;

{----------------------------------------------------------------------------}
Procedure WaitInt;
var timer:word; WasInt:byte;
begin
  WasInt:=0; timer:=4000;
  While (WasInt=0)AND(Timer>0) DO begin
   dec(timer); delay(1);
   asm
      push DS
      push AX
      xor  AX, AX
      mov  DS, AX
      test byte ptr DS:[43Eh], 80h
      jz   @noInt
      and  byte ptr DS:[43Eh], 7Fh
      mov  WasInt, 1
   @noInt:
      pop  AX
      pop  DS
   end;
  end;
  IF WasInt=0 then IOError:=eTimeOut;
end;


{----------------------------------------------------------------------------}
procedure StartDrive(drv:byte);
begin
if drv=0 then port[$3F2]:=28 else port[$3F2]:=45;
delay(100);
end;


{----------------------------------------------------------------------------}
procedure zxSeek(drv,trck:byte);
begin
StartDrive(drv);
out_fdc(15);
out_fdc(drv);
out_fdc(trck);
waitint;
delay(100);
end;


{----------------------------------------------------------------------------}
{  祭 㪠⥫ p  稭 Off}
procedure IncPtr(VAR p:pointer; Off:Word);
  begin
    asm
      push      ds
      lds       di,p
      mov       ax,Off
      add       [di],ax
      jnc       @1
      add       word ptr [di+2],1000h
  @1: pop       ds
    end;
  end;
{ ८ࠧ 㪠⥫  ࠭  ᬥ饭  DMA}
procedure ConvPtr(p:Pointer; VAR Page,Off:Word);
  begin
    asm
      push      ds
      lds       dx,p
      mov       bx,ds
      mov       ax,bx
      mov       cl,4
      shl       ax,cl
      add       ax,dx
      pushf
      lds       di,off
      mov       [di],ax
      mov       ax,bx
      mov       cl,12
      shr       ax,cl
      popf
      jnc        @1
      inc       ax
  @1: lds       di,page
      mov       [di],ax
      pop       ds
    end;
  end;
{----------------------------------------------------------------------------}
procedure ReadSector(drv,trck,hd,sctr,qnt:byte);
var
    BlockSize:word;
    DMAPage,DMAOfs:word;
begin
{ᨬ 5 ᥪ  ⪫祭  ᫥ ⥭ }
  asm
   push DS
   push AX
   xor  AX, AX
   mov  DS, AX
   mov  byte ptr DS:[440h], 90
   pop  AX
   pop  DS
  end;
{ணࠬ஢ DMA}
  ConvPtr(@FDCbuf,DMAPage,DMAOfs);{}
  BlockSize:=qnt*(128 SHL 1);
  asm cli end;
{  port[$0A]:=$06;                   { ᪨஢ 2  }
  port[$0C]:=$46;                   {  ਣ }
  port[$0B]:=$46;                   { ०: FDD -> Memory }
  port[$04]:=DMAOfs AND $FF;        { ᬥ饭  ࠭ DMA, .  }
  port[$04]:=DMAOfs SHR 8;          { ᬥ饭  ࠭ DMA, .  }
  port[$81]:=DMAPage AND $FF;       { ࠭ DMA }
  port[$05]:=(BlockSize-1) AND $FF; { ࠧ , .  }
  port[$05]:=(BlockSize-1) SHR 8;   { ࠧ , .  }
  port[$0A]:=$02;                   { ࠧ᪨஢ 2  }
  asm sti end;
{ ⥭}
Out_FDC($46);
IF hd>0 THEN Out_FDC(drv OR $04) ELSE Out_FDC(drv);
Out_FDC(Trck);
if HobetaBUG then Out_FDC(0) else Out_FDC(Hd);
Out_FDC(Sctr);
Out_FDC(1);
Out_FDC(16);
Out_FDC($1B);
Out_FDC($FF);
{믮塞}
WaitInt;
{⠥ १}
status[0]:=in_fdc;
status[1]:=in_fdc;
status[2]:=in_fdc;
status[3]:=in_fdc;
status[4]:=in_fdc;
status[5]:=in_fdc;
status[6]:=in_fdc;
Out_FDC(4);
Out_FDC(drv);
status[7]:=in_fdc;
{㥬}
IOError:=0;
if (status[0] and $C0)<>0 then
 begin
  IOError:=eUnknownError;
  if TestBit(status[0],3) then IOError:=eDriveNotReady;
  if TestBit(status[1],7) then IOError:=eEndOfCylinder;
  if TestBit(status[1],5) or TestBit(status[2],5) or TestBit(status[2],0)
     then IOError:=eBadSector;
  if TestBit(status[1],2) or TestBit(status[1],4) then IOError:=eSectorNotFound;
  if TestBit(status[1],4) then IOError:=eDMAError;
 end;
if (TestBit(status[7],1)) then IOError:=eDriveNotReady;
end;

{----------------------------------------------------------------------------}
procedure WriteSector(drv,trck,hd,sctr,qnt:byte);
var
    BlockSize:word;
    DMAPage,DMAOfs:word;
begin
{ᨬ 5 ᥪ  ⪫祭  ᫥ ⥭ }
  asm
   push DS
   push AX
   xor  AX, AX
   mov  DS, AX
   mov  byte ptr DS:[440h], 90
   pop  AX
   pop  DS
  end;
{ணࠬ஢ DMA}
  ConvPtr(@FDCbuf,DMAPage,DMAOfs);{}
  BlockSize:=qnt*(128 SHL 1);
  asm cli end;
{  port[$0A]:=$06;                   { ᪨஢ 2  }
  port[$0C]:=$4A;                   {  ਣ }
  port[$0B]:=$4A;                   { ०: Memory -> FDD }
  port[$04]:=DMAOfs AND $FF;        { ᬥ饭  ࠭ DMA, .  }
  port[$04]:=DMAOfs SHR 8;          { ᬥ饭  ࠭ DMA, .  }
  port[$81]:=DMAPage AND $FF;       { ࠭ DMA }
  port[$05]:=(BlockSize-1) AND $FF; { ࠧ , .  }
  port[$05]:=(BlockSize-1) SHR 8;   { ࠧ , .  }
  port[$0A]:=$02;                   { ࠧ᪨஢ 2  }
  asm sti end;
{ }
Out_FDC($45);
IF hd>0 THEN Out_FDC(drv OR $04) ELSE Out_FDC(drv);
Out_FDC(Trck);
if HobetaBUG then Out_FDC(0) else Out_FDC(Hd);
Out_FDC(Sctr);
Out_FDC(1);
Out_FDC(16);
Out_FDC($1B);
Out_FDC($FF);
{믮塞}
WaitInt;
{⠥ १}
status[0]:=in_fdc;
status[1]:=in_fdc;
status[2]:=in_fdc;
status[3]:=in_fdc;
status[4]:=in_fdc;
status[5]:=in_fdc;
status[6]:=in_fdc;
Out_FDC(4);
Out_FDC(drv);
status[7]:=in_fdc;
{㥬}
IOError:=0;
if (status[0] and $C0)<>0 then
 begin
  IOError:=eUnknownError;
  if TestBit(status[0],3) then IOError:=eDriveNotReady;
  if TestBit(status[1],7) then IOError:=eEndOfCylinder;
  if TestBit(status[1],5) or TestBit(status[2],5) or TestBit(status[2],0)
     then IOError:=eBadSector;
  if TestBit(status[1],2) or TestBit(status[1],4) then IOError:=eSectorNotFound;
  if TestBit(status[1],4) then IOError:=eDMAError;
 end;
if (TestBit(status[7],1)) then IOError:=eDriveNotReady;
end;

{----------------------------------------------------------------------------}
Procedure FormatTrack(Drv,Trck,Had:Byte; HB:boolean);
var
    BlockSize: Word;
    DMAPage,DMAOfs:word;
    i:integer;
begin
  asm { 稪 [0:440] 騩 ⠭  ᪥ ᨬ 5 ᥪ}
   push DS
   push AX
   xor  AX, AX
   mov  DS, AX
   mov  byte ptr DS:[440h], 90
   pop  AX
   pop  DS
  end;
  IOError:=eOk;
{ ࠬ C,H,R,N   ᥪ  ஦}
  for i:=0 to 15 do begin
   FDCbuf[i*4+1]:=Trck;                                 {C}
   if HB then FDCbuf[i*4+2]:=0 else FDCbuf[i*4+2]:=had; {H}
   FDCbuf[i*4+3]:=i+1;                                  {R}
   FDCbuf[i*4+4]:=1;      {SectorSize - 1 - 256 bytes}  {N}
  end;
{ணࠬ஢ DMA}
  ConvPtr(@FDCbuf,DMAPage,DMAOfs);{}
  BlockSize:=16*4;
  asm cli end;
{  port[$0A]:=$06;                   { ᪨஢ 2  }
  port[$0C]:=$4A;                   {  ਣ }
  port[$0B]:=$4A;                   { ०: Memory -> FDD }
  port[$04]:=DMAOfs AND $FF;        { ᬥ饭  ࠭ DMA, .  }
  port[$04]:=DMAOfs SHR 8;          { ᬥ饭  ࠭ DMA, .  }
  port[$81]:=DMAPage AND $FF;       { ࠭ DMA }
  port[$05]:=(BlockSize-1) AND $FF; { ࠧ , .  }
  port[$05]:=(BlockSize-1) SHR 8;   { ࠧ , .  }
  port[$0A]:=$02;                   { ࠧ᪨஢ 2  }
  asm sti end;
  { ନ஢ ਪ }
  Out_FDC($4D);
  IF Had>0 THEN Out_FDC(Drv OR $04) ELSE Out_FDC(Drv);
  Out_FDC(1);    {SectorSize}
  Out_FDC(16);   {EOT}
  Out_FDC($32);  {GPLF}
  Out_FDC($00);  {FillByte}
{믮塞}
WaitInt;
{⠥ १}
status[0]:=in_fdc;
status[1]:=in_fdc;
status[2]:=in_fdc;
status[3]:=in_fdc;
status[4]:=in_fdc;
status[5]:=in_fdc;
status[6]:=in_fdc;
Out_FDC(4);
Out_FDC(drv);
status[7]:=in_fdc;
{㥬}
IOError:=0;
if (status[0] and $C0)<>0 then
 begin
  IOError:=eUnknownError;
  if TestBit(status[0],3) then IOError:=eDriveNotReady;
  if TestBit(status[1],7) then IOError:=eEndOfCylinder;
  if TestBit(status[1],5) or TestBit(status[2],5) or TestBit(status[2],0)
     then IOError:=eBadSector;
  if TestBit(status[1],2) or TestBit(status[1],4) then IOError:=eSectorNotFound;
  if TestBit(status[1],4) then IOError:=eDMAError;
 end;
if (TestBit(status[7],1)) then IOError:=eDriveNotReady;
end;

{----------------------------------------------------------------------------}
function initFDD(drv:byte; init:boolean):boolean;
var speed:byte;
    SRT,HUT,HLT:byte;
begin
InitFDD:=true;
port[$3F2]:=8;
StartDrive(drv);
out_fdc(7); out_fdc(drv); waitint;
out_fdc(7); out_fdc(drv); waitint;
SRT:=$F;
HUT:=$D;
HLT:=$1;
Out_FDC($03);
Out_FDC(SRT OR (HUT SHL 4));
Out_FDC(HLT SHL 1);
{᪮  㬮砭 250 /  A:  300 /  B:}
if drv=0 then port[$3F7]:=2 else port[$3F7]:=1;
if init then
 begin
  InitFDD:=false;
  for speed:=0 to 2 do begin
   port[$3F7]:=speed; ReadSector(drv,0,0,9,1);
   if IOError=eOk then begin InitFDD:=true; break; end;
  end;
  if IOError<>eOk then exit;
  ReadSector(drv,0,1,9,1);
  if IOError<>eOk then HobetaBUG:=true else HobetaBUG:=false;
  zxSeek(drv,1); ReadSector(drv,1,0,9,1);
  IOError:=0;
 end;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
begin
end.