uses crt;
const
  {  訡 }
  eOk=0;
  eBadController =1;
  eTimeOut       =2;
  eSeekError     =3;
  eDriveNotReady =4;
  eEndOfCylinder =5;
  eBadSector     =6;
  eDMAError      =7;
  eSectorNotFound=8;
  eWriteProtect  =9;
  eUnknownError  =10;

type
    tbuffer=array[1..4096]of byte;
var
    tmp,buffer: tbuffer;
    DMAPage,DMAOfs:word;

    drive, track, head, sector, quant:byte;
    status:array[1..8]of byte;

    i:integer;
    IOError:byte;
    HOBBUG:boolean;

{----------------------------------------------------------------------------}
function ErrorStr(err:byte):string;
begin
Case err of
 0: ErrorStr:='Ok              ';
 1: ErrorStr:='Bad Controller  ';
 2: ErrorStr:='Time Out        ';
 3: ErrorStr:='Seek Error      ';
 4: ErrorStr:='Drive Not Ready ';
 5: ErrorStr:='End Of Cylinder ';
 6: ErrorStr:='Bad Sector      ';
 7: ErrorStr:='DMA Error       ';
 8: ErrorStr:='Sector Not Found';
 9: ErrorStr:='Write Protect   ';
 10:ErrorStr:='Unknown Error   ';
 27:ErrorStr:='User Break      ';
End;
end;

{----------------------------------------------------------------------------}
Function TestBit(Num, Bit: Byte): Boolean;
const  Bits: ARRAY[0..7] OF Word = (1,2,4,8,16,32,64,128);
begin
  TestBit:=(Num AND Bits[Bit])<>0;
end;

{----------------------------------------------------------------------------}
Function In_FDC: Byte; VAR i: LongInt; begin
  i:=128;
  While (port[$3F4] AND $C0)<>$C0 DO BEGIN Dec(i); IF i=0 THEN Exit; END;
  IF i<>0 THEN In_FDC:=port[$3F5] ELSE IOError:=eTimeOut;
end;

{----------------------------------------------------------------------------}
Procedure Out_FDC(Comm: Byte); VAR i: LongInt; begin
  i:=128;
  While (port[$3F4] AND $C0)<>$80 DO BEGIN Dec(i); IF i=0 THEN Exit; END;
  IF i<>0 THEN port[$3F5]:=Comm ELSE IOError:=eTimeOut;
end;

{----------------------------------------------------------------------------}
Procedure WaitInt;
var timer:word; WasInt:byte;
begin
  WasInt:=0; timer:=4000;
  While (WasInt=0)AND(Timer>0) DO begin
   dec(timer); delay(1);
   asm
      push DS
      push AX
      xor  AX, AX
      mov  DS, AX
      test byte ptr DS:[43Eh], 80h
      jz   @noInt
      and  byte ptr DS:[43Eh], 7Fh
      mov  WasInt, 1
   @noInt:
      pop  AX
      pop  DS
   end;
  end;
  IF WasInt=0 then IOError:=eTimeOut;
end;


{----------------------------------------------------------------------------}
procedure StartDrive(drv:byte);
begin
if drv=0 then port[$3F2]:=28 else port[$3F2]:=45;
delay(500);
end;


{----------------------------------------------------------------------------}
procedure zxSeek(drv,trck:byte);
begin
StartDrive(drv);
out_fdc(15);
out_fdc(drv);
out_fdc(trck);
waitint;
delay(50);
end;

{----------------------------------------------------------------------------}
  {  祭 㪠⥫ p  稭 Off}
  procedure IncPtr(VAR p:pointer; Off:Word);
  begin
    asm
      push      ds
      lds       di,p
      mov       ax,Off
      add       [di],ax
      jnc       @1
      add       word ptr [di+2],1000h
  @1: pop       ds
    end;
  end;
  { ८ࠧ 㪠⥫  ࠭  ᬥ饭  DMA}
  procedure ConvPtr(p:Pointer; VAR Page,Off:Word);
  begin
    asm
      push      ds
      lds       dx,p
      mov       bx,ds
      mov       ax,bx
      mov       cl,4
      shl       ax,cl
      add       ax,dx
      pushf
      lds       di,off
      mov       [di],ax
      mov       ax,bx
      mov       cl,12
      shr       ax,cl
      popf
      jnc        @1
      inc       ax
  @1: lds       di,page
      mov       [di],ax
      pop       ds
    end;
  end;
{----------------------------------------------------------------------------}
procedure ReadSector(drv,trck,hd,sctr,qnt:byte);
var
    BlockSize:word;
    DMAAddr:longint;
label
    NO_CARRY;
begin
{ᨬ 5 ᥪ  ⪫祭  ᫥ ⥭ }
  asm
   push DS
   push AX
   xor  AX, AX
   mov  DS, AX
   mov  byte ptr DS:[440h], 90
   pop  AX
   pop  DS
  end;
{ணࠬ஢ DMA}
  ConvPtr(@buffer,DMAPage,DMAOfs);{}
  BlockSize:=qnt*(128 SHL 1);
  asm cli end;
  port[$0A]:=$06;                   { ᪨஢ 2  }
  port[$0C]:=$46;                   {  ਣ }
  port[$0B]:=$46;                   { ०: FDD -> Memory }
  port[$04]:=DMAOfs AND $FF;        { ᬥ饭  ࠭ DMA, .  }
  port[$04]:=DMAOfs SHR 8;          { ᬥ饭  ࠭ DMA, .  }
  port[$81]:=DMAPage AND $FF;       { ࠭ DMA }
  port[$05]:=(BlockSize-1) AND $FF; { ࠧ , .  }
  port[$05]:=(BlockSize-1) SHR 8;   { ࠧ , .  }
  port[$0A]:=$02;                   { ࠧ᪨஢ 2  }
  asm sti end;
{ ⥭}
Out_FDC($46);
IF hd>0 THEN Out_FDC(drv OR $04) ELSE Out_FDC(drv);
Out_FDC(Trck);
if HOBBUG then Out_FDC(0) else Out_FDC(Hd);
Out_FDC(Sctr);
Out_FDC(1);
Out_FDC(16);
Out_FDC($1B);
Out_FDC($FF);
{믮塞}
WaitInt;
{⠥ १}
status[1]:=in_fdc;
status[2]:=in_fdc;
status[3]:=in_fdc;
status[4]:=in_fdc;
status[5]:=in_fdc;
status[6]:=in_fdc;
status[7]:=in_fdc;
Out_FDC(4);
Out_FDC(drv);
status[8]:=in_fdc;
{㥬}
IOError:=0;
if (status[1] and $C0)<>0 then
 begin
  IOError:=eUnknownError;
  if TestBit(status[1],3) then IOError:=eDriveNotReady;
  if TestBit(status[2],7) then IOError:=eEndOfCylinder;
  if TestBit(status[2],5) or TestBit(status[3],5) or TestBit(status[3],0)
     then IOError:=eBadSector;
  if TestBit(status[2],2) or TestBit(status[2],4) then IOError:=eSectorNotFound;
  if TestBit(status[2],4) then IOError:=eDMAError;
 end;
if (TestBit(status[8],1)) then IOError:=eDriveNotReady;
end;



{----------------------------------------------------------------------------}
procedure WriteSector(drv,trck,hd,sctr,qnt:byte);
var
    BlockSize:word;
    DMAAddr:longint;
label
    NO_CARRY;
begin
{ᨬ 5 ᥪ  ⪫祭  ᫥ ⥭ }
  asm
   push DS
   push AX
   xor  AX, AX
   mov  DS, AX
   mov  byte ptr DS:[440h], 90
   pop  AX
   pop  DS
  end;
{ணࠬ஢ DMA}
  ConvPtr(@buffer,DMAPage,DMAOfs);{}
  BlockSize:=qnt*(128 SHL 1);
  asm cli end;
  port[$0A]:=$06;                   { ᪨஢ 2  }
  port[$0C]:=$4A;                   {  ਣ }
  port[$0B]:=$4A;                   { ०: Memory -> FDD }
  port[$04]:=DMAOfs AND $FF;        { ᬥ饭  ࠭ DMA, .  }
  port[$04]:=DMAOfs SHR 8;          { ᬥ饭  ࠭ DMA, .  }
  port[$81]:=DMAPage AND $FF;       { ࠭ DMA }
  port[$05]:=(BlockSize-1) AND $FF; { ࠧ , .  }
  port[$05]:=(BlockSize-1) SHR 8;   { ࠧ , .  }
  port[$0A]:=$02;                   { ࠧ᪨஢ 2  }
  asm sti end;
{ }
Out_FDC($45);
IF hd>0 THEN Out_FDC(drv OR $04) ELSE Out_FDC(drv);
Out_FDC(Trck);
if HOBBUG then Out_FDC(0) else Out_FDC(Hd);
Out_FDC(Sctr);
Out_FDC(1);
Out_FDC(16);
Out_FDC($1B);
Out_FDC($FF);
{믮塞}
WaitInt;
{⠥ १}
status[1]:=in_fdc;
status[2]:=in_fdc;
status[3]:=in_fdc;
status[4]:=in_fdc;
status[5]:=in_fdc;
status[6]:=in_fdc;
status[7]:=in_fdc;
Out_FDC(4);
Out_FDC(drv);
status[8]:=in_fdc;
{㥬}
IOError:=0;
if (status[1] and $C0)<>0 then
 begin
  IOError:=eUnknownError;
  if TestBit(status[1],3) then IOError:=eDriveNotReady;
  if TestBit(status[2],7) then IOError:=eEndOfCylinder;
  if TestBit(status[2],5) or TestBit(status[3],5) or TestBit(status[3],0)
     then IOError:=eBadSector;
  if TestBit(status[2],2) or TestBit(status[2],4) then IOError:=eSectorNotFound;
  if TestBit(status[2],4) then IOError:=eDMAError;
 end;
if (TestBit(status[8],1)) then IOError:=eDriveNotReady;
end;



{----------------------------------------------------------------------------}
Procedure FormatTrack(Drv,Trck,Had:Byte; HB:boolean);
var BlockSize: Word;
begin
  asm { 稪 [0:440] 騩 ⠭  ᪥ ᨬ 5 ᥪ}
   push DS
   push AX
   xor  AX, AX
   mov  DS, AX
   mov  byte ptr DS:[440h], 90
   pop  AX
   pop  DS
  end;
  IOError:=eOk;
{ ࠬ C,H,R,N   ᥪ  ஦}
  for i:=0 to 15 do begin
   Buffer[i*4+1]:=Trck;                                               {C}
   if HB then Buffer[i*4+2]:=0 else Buffer[i*4+2]:=had; {H}
   Buffer[i*4+3]:=i+1;                                                 {R}
   Buffer[i*4+4]:=1{DriveParams^.SectorSize};                          {N}
  end;
{ணࠬ஢ DMA}
  ConvPtr(@buffer,DMAPage,DMAOfs);{}
  BlockSize:=16*4;
  asm cli end;
{  port[$0A]:=$06;                   { ᪨஢ 2  }
  port[$0C]:=$4A;                   {  ਣ }
  port[$0B]:=$4A;                   { ०: Memory -> FDD }
  port[$04]:=DMAOfs AND $FF;        { ᬥ饭  ࠭ DMA, .  }
  port[$04]:=DMAOfs SHR 8;          { ᬥ饭  ࠭ DMA, .  }
  port[$81]:=DMAPage AND $FF;       { ࠭ DMA }
  port[$05]:=(BlockSize-1) AND $FF; { ࠧ , .  }
  port[$05]:=(BlockSize-1) SHR 8;   { ࠧ , .  }
  port[$0A]:=$02;                   { ࠧ᪨஢ 2  }
  asm sti end;
  { ନ஢ ਪ }
  Out_FDC($4D);
  IF Had>0 THEN Out_FDC(Drive OR $04) ELSE Out_FDC(Drive);
  Out_FDC(1{DriveParams^.SectorSize});
  Out_FDC(16{DriveParams^.EOT});
  Out_FDC($32{DriveParams^.GPLF});
  Out_FDC($00{DriveParams^.FillByte});
{믮塞}
WaitInt;
{⠥ १}
status[1]:=in_fdc;
status[2]:=in_fdc;
status[3]:=in_fdc;
status[4]:=in_fdc;
status[5]:=in_fdc;
status[6]:=in_fdc;
status[7]:=in_fdc;
Out_FDC(4);
Out_FDC(drv);
status[8]:=in_fdc;
{㥬}
IOError:=0;
if (status[1] and $C0)<>0 then
 begin
  IOError:=eUnknownError;
  if TestBit(status[1],3) then IOError:=eDriveNotReady;
  if TestBit(status[2],7) then IOError:=eEndOfCylinder;
  if TestBit(status[2],5) or TestBit(status[3],5) or TestBit(status[3],0)
     then IOError:=eBadSector;
  if TestBit(status[2],2) or TestBit(status[2],4) then IOError:=eSectorNotFound;
  if TestBit(status[2],4) then IOError:=eDMAError;
 end;
if (TestBit(status[8],1)) then IOError:=eDriveNotReady;
end;




{----------------------------------------------------------------------------}
function initFDD(drv:byte; e:boolean):boolean;
var speed:byte;
    SRT,HUT,HLT:byte;
begin
InitFDD:=true;
port[$3F2]:=8;
StartDrive(drv);
out_fdc(7); out_fdc(drv); waitint;
out_fdc(7); out_fdc(drv); waitint;
SRT:=$F;
HUT:=$D;
HLT:=$1;
Out_FDC($03);
Out_FDC(SRT OR (HUT SHL 4));
Out_FDC(HLT SHL 1);
{᪮  㬮砭 300 /  B:  250 /  A:}
if drv=0 then port[$3F7]:=2 else port[$3F7]:=1;
{
  speed:=0;
  write(' ।  ');
  case speed of
   0: writeln('500 kb/s');
   1: writeln('300 kb/s');
   2: writeln('250 kb/s');
  end;
  port[$3F7]:=speed;
  writeln;
{HOBBUG:=false;{}
if e then
 begin
  InitFDD:=false;
  for speed:=0 to 2 do begin
   port[$3F7]:=speed; ReadSector(drv,0,0,9,1);
    if IOError=eOk then begin InitFDD:=true; break; end;
  end;
  if IOError<>eOk then exit;
  write(' ।  ');
  case speed of
   0: writeln('500 kb/s');
   1: writeln('300 kb/s');
   2: writeln('250 kb/s');
  end;
  ReadSector(drv,0,1,9,1);
  if IOError<>eOk then writeln('HOBETA FORMATTED');
  if IOError<>eOk then HOBBUG:=true else HOBBUG:=false;
  zxSeek(drive,1); ReadSector(drive,1,0,9,1);
  IOError:=0;
 end;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
var ff:file of tbuffer;
    try,t_,h_,s_:byte;
    d:string;
    wrfile:string;
    saved:boolean;
begin
clrscr;;
drive:=0;
wrfile:='_test.trd';

if paramCount>0 then
 begin
  d:=paramStr(1);
  if UpCase(d[1])='A' then drive:=0;
  if paramCount>1 then wrfile:=paramStr(2);
 end;

writeln('ZX Spectrum Navigator v.1.14  뢠 ᪥  ଠ TR-DOS');
writeln('http://www.sn.nnov.ru, rom@sn.nnov.ru');
writeln('******************************************************************');
writeln(' : WR-TRDOS.EXE <㪢 ᪠> < 䠩>');
writeln(' -   ࠬ -  B: 䠩 _test.trd');
writeln('******************************************************************');
writeln;
writeln(' ',chr(drive+65),': 䠩 ',wrfile);
writeln('뢠 ᪥? (ESC - ࢠ)');
if readkey=#27 then begin writeln('ࢠ 짮⥫.'); exit; end;

gotoxy(1,wherey-1); write('뢠 ᪥'); writeln(' (  - ⠭)...');
if not initFDD(drive,true) then begin writeln('no TR-DOS disk'); exit; end;
{$I-}
saved:=false;
assign(ff,wrfile); reset(ff);
if IOResult<>0 then begin writeln('訡  ⥭ 䠩 ',wrfile); exit; end;
for t_:=0 to 79 do begin
 zxSeek(drive,t_);
 for h_:=0 to 1 do begin
  for i:=1 to 4096 do buffer[i]:=0;
  read(ff,buffer);
  for i:=1 to 4096 do tmp[i]:=buffer[i];
  if IOResult<>0 then begin saved:=true; break; end;
  for try:=1 to 3 do begin WriteSector(drive,t_,h_,1,16); if IOError=eOk then break; end;
  write('Track:',t_:2,'  Head:',h_,'  ');{}
  if IOError<>0 then
   Begin
    for s_:=1 to 16 do
     begin
      for i:=1 to 256 do buffer[i]:=tmp[(s_-1)*256+i];
      for try:=1 to 3 do begin WriteSector(drive,t_,h_,s_,1); if IOError=eOk then break; end;
      if IOError=0 then write(chr($10)) else write('B');
     end;
    writeln;
   End else write(ErrorStr(IOError),#13);{}
  if keypressed then break;
  if saved then break;
 end;
if keypressed then break;
if saved then break;
end;
if keypressed then begin readkey; exit; end;

close(ff);
{$I+}
  Writeln;
  Writeln('᪥ ᠭ.');
  readkey;

end.